TweakHub = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceDB-2.0", "AceModuleCore-2.0", "FuBarPlugin-2.0")
TweakHub:RegisterDB("TweakHubDB")

TweakHub.Tablet = AceLibrary("Tablet-2.0")
TweakHub.Locale = AceLibrary("AceLocale-2.2"):new("TweakHub")

TweakHub.Text = "TweakHub"

local L = TweakHub.Locale
local T = TweakHub.Tablet

local options = {
	type = "group",
	args = {
		{
			type = "header",
			order = 998,
		},
		{
			type = "execute",
			name = L["Clear Option Tables"],
			desc = L["Clear option tables to save addon memory."],
			func = function () TweakHub:ClearOptionTables() end,
			order = 999
		}
	},
}

function TweakHub:OnInitialize()
	TweakHub.hideWithoutStandby = true
	TweakHub.hasIcon = true

	TweakHub:RegisterChatCommand({"/tweakhub", "/th"}, options)
	TweakHub.OnMenuRequest = options

	TweakHub:SetText("TweakHub")
end

function TweakHub:OnEnable()
	if TweakHub:IsIconShown() then
		TweakHub:SetIcon("Interface\\Icons\\Spell_Nature_TimeStop")
	else
		TweakHub:HideIcon()
	end

	TweakHub:ClearOptionTables()
end

function TweakHub:OnTooltipUpdate()
	T:SetHint(L["Right-Click to change options."])
end

function TweakHub:OnTextUpdate()
	TweakHub:SetText(TweakHub.Text)
end

function TweakHub:ClearOptionTables()
	for name, module in TweakHub:IterateModules() do
		options.args[name] = {
			type = "execute",
			name = name,
			desc = format(L["Load options table for %s."], name),
			func = function() options.args[name] = TweakHub[name]:GetOptionsTable() end
		}
	end
	collectgarbage()
end